import {NS} from "@ns"
import {getHackability,getLockSymbol} from "./lib/hack";

/** @param {NS} ns */
// eslint-disable-next-line require-await
export async function main(ns: NS): Promise<void> {
    findServer(ns, 'home', 'home', 1);
}

/** @param {NS} ns
 * @param {string} startServer
 * @param {string} targetServer
 * @param {number} depth
*/
function findServer(ns: NS, startServer: string, targetServer: string, depth: number): void {
    const servers = ns.scan(targetServer)
        .filter((server) => server !== startServer);
    servers.forEach((server) => {
        const lock = getHackability(ns, server);
        const lock_symbol = getLockSymbol(lock);
        const info = ns.getServer(server);
        ns.tprint(`😹${'>'.repeat(depth)} ${lock_symbol} ${server} ${info.backdoorInstalled ? '✅': '❌'}`);
        if (lock !== "impossible") {
            findServer(ns, targetServer, server, depth + 1);
        }
    });
}